#include <gtk/gtk.h>

enum {COL_ID, COL_TITRE, COL_NB_EXMP, COL_AUTOR};


typedef struct{
  GtkWidget *win;
  GtkWidget* tree_v;
}WinData;


void show_autor_dialog(GtkTreeView* tv, GtkTreePath *path, GtkTreeViewColumn *column, gpointer uData){
  WinData*     uWData = uData;
  GtkWidget*   autorLab;
  GtkWidget*   diagArea;
  GtkTreeIter  iter;
  gchar*       authorName="Vide";
 
  GtkTreeModel* tmpLst;

  //récupéré le nom de l'auteur 
  tmpLst = gtk_tree_view_get_model(tv);
  if (gtk_tree_model_get_iter(tmpLst, &iter, path)){
    gtk_tree_model_get(tmpLst, &iter, COL_AUTOR, &authorName, -1);
  }
  
  
  //création de la boite de dialogue
  GtkWidget * diag = gtk_dialog_new_with_buttons("Saisir une valeur",
                                                 GTK_WINDOW(uWData->win),
                                                 GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                                 "OK", GTK_RESPONSE_ACCEPT,
                                                 NULL);

  //récupérer le container de la boite de dialogue
  diagArea = gtk_dialog_get_content_area (GTK_DIALOG (diag));
  gtk_container_set_border_width (GTK_CONTAINER (diagArea), 10);
  
  //créer un label pour afficher l'auteur 
  autorLab = gtk_label_new(authorName);

  
  

  //ajouter le label à boite de dialogue
  gtk_container_add (GTK_CONTAINER (diagArea), autorLab);
  
  //aficher les éléments de la boite de dialogue
  gtk_widget_show_all (diag);

  // Affciher la boite de dialogue et récupérer la valeur du bouton 
  gint res = gtk_dialog_run(GTK_DIALOG(diag));
  gtk_widget_destroy(diag);
  g_free(authorName);
}



int main(int argc, char* argv[]){

  WinData  wdata;
  gtk_init(&argc, &argv);

  /****************************
   * Création de la fenêtre
   ****************************/
  

  wdata.win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  g_signal_connect (G_OBJECT(wdata.win),"delete_event",G_CALLBACK(gtk_main_quit) ,NULL);
  


  /****************************
   * Création du modèle 
   ****************************/
  
  GtkListStore* lst;
  

  //création d'une listeavec 3 colonnes, on indiquant leurs types
  lst = gtk_list_store_new ( 4 , G_TYPE_INT , G_TYPE_STRING, G_TYPE_INT, G_TYPE_STRING);

  // ajouter une ligne vide à la position iter
  GtkTreeIter iter; 
  gtk_list_store_prepend(lst, &iter);

  //insérer un élément dans la ligne nouvellement crée à la position iter
  gtk_list_store_set(lst, &iter, COL_ID, 1 , COL_TITRE, "Le Vieil Homme et la Mer", COL_NB_EXMP, 27, COL_AUTOR, "Ernest Hemingway", -1);

  // un autre élément 
  gtk_list_store_append(lst, &iter);
  gtk_list_store_set(lst, &iter, COL_ID, 2 , COL_TITRE, "L'étranger", COL_NB_EXMP, 15, COL_AUTOR, "Albert Camus", -1);

  // et un autre 
  gtk_list_store_append(lst, &iter);
  gtk_list_store_set(lst, &iter, COL_ID, 3 , COL_TITRE, "Une étude en rouge", COL_NB_EXMP, 19, COL_AUTOR, "Arthur Conan Doyle",  -1);


  
  /****************************
   * Création de la vue
   ****************************/

  // créarion de la vue
  wdata.tree_v  = gtk_tree_view_new();
  gtk_tree_view_set_model(GTK_TREE_VIEW(wdata.tree_v), GTK_TREE_MODEL(lst));

  g_signal_connect (G_OBJECT(wdata.tree_v),"row-activated",G_CALLBACK(show_autor_dialog) ,&wdata);

  //créaton des styles d'une cellules d'une colonne
  GtkCellRenderer* cellRand_id = gtk_cell_renderer_text_new();
  GtkCellRenderer* cellRand_title = gtk_cell_renderer_text_new();
  GtkCellRenderer* cellRand_nbr  = gtk_cell_renderer_text_new();

  //création des colonnes
  GtkTreeViewColumn* col_id = gtk_tree_view_column_new_with_attributes("ID", cellRand_id, "text", COL_ID, NULL);
  GtkTreeViewColumn* col_title = gtk_tree_view_column_new_with_attributes("Titre", cellRand_title, "text", COL_TITRE, NULL);
  GtkTreeViewColumn* col_nbr = gtk_tree_view_column_new_with_attributes("NB exemplaires", cellRand_nbr,"text", COL_NB_EXMP, NULL);

  //Ajouter les colonnes 
  gtk_tree_view_append_column(GTK_TREE_VIEW(wdata.tree_v), col_id);
  gtk_tree_view_append_column(GTK_TREE_VIEW(wdata.tree_v), col_title);
  gtk_tree_view_append_column(GTK_TREE_VIEW(wdata.tree_v), col_nbr);
			      
  
  gtk_container_add(GTK_CONTAINER(wdata.win), wdata.tree_v);
  gtk_widget_show_all(wdata.win);
  gtk_main();
  return 0;
}
